<template>
    <div class="edit-switch">
        <slot name="editable" :edit="editData"></slot>
        <switch-edit-icon v-if="isEditable" v-model="isEditMode" @input="switchEditMode()" class="edit-switch_btns" />
    </div>
</template>

<script>
import SwitchEditIcon from '@bloomio/spa-admin-common/components/switch-edit-icon';

export default {
    components: {
        SwitchEditIcon,
    },
    props: {
        editedValue: {
            type: [Object, Boolean],
            required: false,
        },
        isEditable: {
            type: Boolean,
            required: false,
        },
        editConfig: {
            type: Object,
            required: false,
        },
    },
    created() {
        // restore edited fields after relogin
        if (this.$router.fromLoginPage) {
            const savedVal = this.editedValue;
            if (savedVal) {
                this.isEditMode = true;
                this.editSetting = { ...this.editSetting, restoreValue: savedVal.value };
            }
        }
    },
    data() {
        return {
            isEditMode: false,
            editSetting: { ...this.editConfig },
        };
    },
    computed: {
        editData: vm => ({ active: vm.isEditMode, ...vm.editSetting }),
    },
    methods: {
        /** Handler for switching edit mode */
        switchEditMode(eventObj) {
            if (eventObj) {
                this.isEditMode = eventObj.status;
            }
            this.$emit('edit', { ...this.editData });
        },
    },
};
</script>


<style lang="stylus" scoped>
.edit-switch
    font-size: 1.6rem
    padding: .5rem 1rem
    display: flex

.edit-switch_btns
    padding-right: 5rem
    margin-left: auto
    display: flex
    align-items: center
</style>
